/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 14-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.api.programs.arguments.internal.argumentInstance;

import uk.ac.ic.doc.kevlar.api.programs.arguments.IArgumentValueVisitor;
import uk.ac.ic.doc.kevlar.api.programs.arguments.ISetArgumentValue;

/**
 * @author Daniel Burke
 *
 */
public class SetArgumentValue extends AbstractArgumentValue implements ISetArgumentValue {

    private static final long serialVersionUID = -7721562752039388193L;
    private String value;
	
	public SetArgumentValue(String value)
	{
		if(value == null)
		{
			throw new IllegalArgumentException("value may not be null");
		}
		this.value = value;
	
	}
	
	public boolean equals(Object o)
	{
	    if(!(o instanceof SetArgumentValue))
	    {
	        return false;
	    }
	    
	    return value.equals(((SetArgumentValue)o).getValue());
	}
	
	/**
	 * @return Returns the value.
	 */
	public String getValue() {
		return value;
	}
	
	public String toString()
	{
		return value;
	}

	public void takeVisitor(IArgumentValueVisitor visitor)
	{
	    visitor.setArg(this);
	}
	
	public static SetArgumentValue valueOf(String name)
	{
	    return new SetArgumentValue(name);
	}
	
}
