/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 22-Oct-2004
 *
 */
package uk.ac.ic.doc.kevlar.core.types.textType;

import java.io.File;

/**
 * @author Daniel Burke
 *
 */
public final class FilenameTypeImpl extends TextTypeImpl implements IFilenameType {

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 1004842572934994055L;
	File backend;
	
	public FilenameTypeImpl(String filename)
	{
		super(filename);
		backend = new File(filename);
	}
	
	public FilenameTypeImpl(File file)
	{
		super(file.getName());
		backend = file;
	}

	public synchronized File getFile() {
		return backend;
	}
	
	public synchronized void setFile(File file)
	{
		backend = file;
	}

	public synchronized String getText() {
		return backend.getName();
	}

	public synchronized String toString() {
	    return backend.getPath();
	}
	
	public synchronized void setText(String filename) {
		backend = new File(filename);
	}

	public synchronized Object clone() {
	        FilenameTypeImpl f = (FilenameTypeImpl)super.clone();
	        return f;
	}
}
