/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 23-Oct-2004 by toa02
 *
 */
package uk.ac.ic.doc.kevlar.experiment.reflect;

import java.lang.reflect.Modifier;
import java.util.Arrays;

/**
 * @author toa02
 *
 */
public class ReflectExp2 {

    
    public static void main(String[] args) {
        System.out.println("ABC:");
        System.out.println("Member:" + ABC.class.isMemberClass());
        System.out.println("Local:" + ABC.class.isLocalClass());
        System.out.println("Constructors" + Arrays.deepToString(ABC.class.getConstructors()));
        
        System.out.println("ReflectExp2:");
        System.out.println("Member:" + ReflectExp2.class.getClass().isMemberClass());
        System.out.println("Local:" + ReflectExp2.class.getClass().isLocalClass());
        System.out.println("Constructors" + Arrays.deepToString(ReflectExp2.class.getConstructors()));
        int modifiers = ReflectExp2.class.getConstructors()[0].getModifiers();
        System.out.println("Constructor is " + Modifier.toString(modifiers));
        System.out.println("Class is:" + Modifier.toString(ReflectExp2.class.getModifiers()));
        
    }
}


class ABC{
    /* just a class thats a class thats a class */
}