/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 14-Oct-2004 by toa02
 *
 */
package uk.ac.ic.doc.kevlar.experiment.reflect;

import java.util.Vector;

/**
 * @author toa02
 *
 */
class ReflectionExperiment {

    public static void main(String[] args) {
        
        Vector<Class> classes = new Vector<Class>();
        
        classes.add(IRootInterface.class);
        classes.add(ISubInterfaceA.class);
        classes.add(ISubInterfaceA2.class);
        classes.add(ISubInterfaceB.class);
        
        classes.add(InterfaceAImpl.class);
        classes.add(InterfaceA2Impl.class);
        classes.add(InterfaceBImpl.class);
        
        
        
        for(Class cClass : classes){
            System.out.println("Class " + getName(cClass) );

            for( Class ints :  cClass.getInterfaces() ){
                System.out.println("\tIterface: " + getName(ints));
            }
            
            System.out.println( "\tSuperClass: " + getName(cClass.getSuperclass()));
        }
        
    }
    
    private static String getName(Class cClass){
        if( cClass == null ){
            return "null";
        }
        cClass.isInterface();
        return cClass.getName().substring(cClass.getName().lastIndexOf('.') +1,cClass.getName().length());
    }
}
