/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 09-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.pipeline.custombuttons;

import org.eclipse.swt.graphics.Point;

import uk.ac.ic.doc.kevlar.gui.internal.pipeline.IProgramGroup;
import uk.ac.ic.doc.kevlar.gui.internal.widgets.SelectableButton;

/**
 * @author Marc
 **/
public class ExpandButton extends SelectableButton {

    private static final String EXPAND_IMAGE = "expand.png";
    private static final String EXPAND_ROLLOVER_IMAGE = "expand_rollover.png";

    private static final String CONTRACT_IMAGE = "contract.png";
    private static final String CONTRACT_ROLLOVER_IMAGE = "contract_rollover.png";

    private IProgramGroup parent;
        
    public ExpandButton(IProgramGroup parent) {

        super(CONTRACT_IMAGE, CONTRACT_ROLLOVER_IMAGE, EXPAND_IMAGE, EXPAND_ROLLOVER_IMAGE);
        this.parent = parent;
        
    }
    
    public void mouseRelease(Point position, int button) {

/*        super.mouseRelease(position, button);
        
        if (isSelected()) {
        
            parent.contract();
            
        } else {
            
            parent.expand();
            
        } */
        
        parent.toggleExpandContract();
        
    }

}
