/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 09-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.pipeline.custombuttons;

import org.eclipse.swt.graphics.Point;

import uk.ac.ic.doc.kevlar.gui.internal.pipeline.Program;
import uk.ac.ic.doc.kevlar.gui.internal.widgets.RollOverButton;

/**
 * @author Marc
 **/
public class ResizeButton extends RollOverButton {

    private static final String RESIZE_IMAGE = "resize.png";
    private static final String RESIZE_ROLLOVER_IMAGE = "resize_rollover.png";

    private Program parent;
    private Point mouseOffset;
        
    public ResizeButton(Program parent) {

        super(RESIZE_IMAGE, RESIZE_ROLLOVER_IMAGE, RESIZE_IMAGE);
        this.parent = parent;
        this.mouseOffset = null;
        
    }
    
    public void mousePress(Point position, int button) {
        
        if (button == 1) {
            
            getMouseFocus();
            mouseOffset = position;
            
        }
        
    }
    
    public void mouseRelease(Point position, int button) {
        
        if (button == 1) {
            
            releaseMouseFocus();
            mouseOffset = null;
            parent.updatePipes();
            
        }
        
    }
    
    public void mouseMoving(Point position) {

        if (mouseOffset != null) {
        
            parent.resize(position.x-mouseOffset.x);
            
        }
        
    }

}
