/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 25-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.showpane;

import uk.ac.ic.doc.kevlar.gui.internal.caches.Utils;
import uk.ac.ic.doc.kevlar.gui.internal.widgets.RollOverButton;

/**
 * @author Daniel Burke
 *
 */
public class HorizontalShowHideButton extends RollOverButton {

    public static final String buttonShow = "showPaneShow";
    public static final String buttonAttention = "showPaneAttention";
    public static final String buttonHide = "showPaneHide";
    
    private boolean expanded = false;
    private boolean attention = false;
    
    public HorizontalShowHideButton() {
        super(buttonShow + Utils.NORMAL, buttonShow + Utils.ROLLOVER, buttonShow + Utils.NORMAL);
        updateState();
    }
    
    public void setAttentionSeeking(boolean attention)
    {
        this.attention = attention;
        
        updateState();
    }
    
    public void setExpanded(boolean expanded)
    {
        this.expanded = expanded;
        
        updateState();
    }
    
    private void updateState()
    {
        String skin = expanded ? buttonHide : (attention ? buttonAttention : buttonShow );
        
        this.setImage(skin + Utils.NORMAL);
        this.setRolloverImage(skin + Utils.ROLLOVER);
        this.setDownImage(skin + Utils.NORMAL);
        
        redraw();
    }
    
    public boolean isExpanded()
    {
        return expanded;
    }
    
    public boolean isAttentionSeeking()
    {
        return attention;
    }
}
