/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 25-Nov-2004
 *
 */

package uk.ac.ic.doc.kevlar.gui.internal.taskpane.searchpane;

import java.util.List;

import org.eclipse.swt.graphics.Point;

import uk.ac.ic.doc.kevlar.core.framework.IProgramIDDescription;
import uk.ac.ic.doc.kevlar.gui.internal.ADrawableObject;
import uk.ac.ic.doc.kevlar.gui.internal.taskpane.TaskPaneManager;
import uk.ac.ic.doc.kevlar.gui.internal.taskpane.programpane.AProgramTreeNodeEntry;
import uk.ac.ic.doc.kevlar.gui.internal.taskpane.programpane.ProgramEntry;
import uk.ac.ic.doc.kevlar.gui.internal.widgets.StretchyBox;
import uk.ac.ic.doc.kevlar.hial.IProgramSearchResult;

/**
 * @author Kate
 *
 */

public class OldResultBox extends StretchyBox {

	private Heading searchResult;
	private SearchPane parent;
	
	public OldResultBox(Point position, SearchPane parent)
	{
		super(false, true);
		this.parent = parent;
		
		setSize(new Point(TaskPaneManager.TASK_PANE_INTERNAL_WIDTH-21, 0));
		
		setPosition(position);	
	}
	
	public void displayResults(List<IProgramSearchResult> results)
	 {
	 	/* display search resutls */
	 	
	 	searchResult = new Heading("Search Results:", new Point (160, 30), new Point(0,0));
		searchResult.setDivider("divider.png");
	 	
		addChild(searchResult);
	 	
	 	int startPos = (int)Math.floor((double)searchResult.getArea().height/AProgramTreeNodeEntry.ENTRY_HEIGHT);
		
		if (results.isEmpty())
		{
			searchResult.setSize(new Point(160,70));
			searchResult.setMessage("Nothing matches your search criteria");
		}
		else
		{
			for (int i=0; i<results.size(); i++)
			{
				IProgramIDDescription result = results.get(i).getProgramDescription();
				ProgramEntry entry = new ProgramEntry(result, startPos+i, parent, 0);
				addChild(entry);				
			}
		}
		
		//updateDimensions();
	 }
}
