/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 25-Dec-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.showers.image;




import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;

import uk.ac.ic.doc.kevlar.gui.internal.ADrawableObject;
import uk.ac.ic.doc.kevlar.gui.internal.caches.ColorCache;
import uk.ac.ic.doc.kevlar.gui.internal.caches.Utils;

/**
 * @author Daniel Burke
 *
 */
public class ImageArea extends ADrawableObject
{
    private Image main;
    private double zoom = 1.0;
    
    public ImageArea()
    {
        super();
    }
    
	public synchronized void drawBefore(GC gc, Rectangle redrawArea)
	{
	    if(main == null)
	    {
	        /*
	        gc.setBackground(ColorCache.get(255, 255, 255));
	        gc.drawRectangle(0 - redrawArea.x,
	                		 0 - redrawArea.y,
	                		 area.width,
	                		 area.height);
	                		 */
	    }
	    else
	    {
	        //Utils.drawImage(gc, 1, 1, 1.0, main, redrawArea);
	        Utils.drawImage(gc, main, new Rectangle(1 - redrawArea.x, 1 - redrawArea.y, area.width - 2, area.height - 2));

	        /*
	        
	        int srcx = redrawArea.x - 1;
	        int srcw = Math.min(redrawArea.width, bounds.width - srcx);	     
	        int destx = redrawArea.x;
	        if(redrawArea.x == 0)
	        {
	            srcx = 0;
	            destx = 1;
	            srcw = Math.min(redrawArea.width - 1, bounds.width - srcx);
	        }
	        int destw = srcw;
	        
	        int srcy = redrawArea.y - 1;
	        int desty = redrawArea.y;
	        int srch = Math.min(redrawArea.height, bounds.height - srcy);	        
	        if(redrawArea.y == 0)
	        {
	            srcy = 0;
	            srch = Math.min(redrawArea.height - 1, bounds.height - srcy);
	        }
	        int desth = srch;
	        
	        gc.drawImage(main, srcx, srcy, srcw, srch, 
	                destx, desty, destw, desth);
	        */
	    }
	}
	
	public synchronized void setImage(Image main)
	{
	    this.main = main;
	}
	
	public synchronized Image getImage()
	{
	    return main;
	}
	
	public synchronized void setZoom(double zoom)
	{
	    this.zoom = zoom;
	}
	
	public synchronized double getZoom()
	{
	    return zoom;
	}
}
